#!/usr/bin/perl -t

#   Return success or failure status based on whether or not a
#   given username/password authenticates using PAM.
#   Caller should write username/password as two lines in a file
#   which is passed to this script as a command line argument.

use POSIX;
use IO::Socket::INET;
use Digest::MD5 qw(md5_hex);

# Get username/password from file
if ($ARG = shift @ARGV) {
    if (!open (UPFILE, "<$ARG")) {
	print "Could not open username/password file: $ARG\n";
	exit 1;
    }
} else {
    print "No username/password file specified on command line\n";
    exit 1;
}

$username = <UPFILE>;
$password = <UPFILE>;

if (!$username || !$password) {
    print "Username/password not found in file: $ARG\n";
    exit 1;
}

chomp $username;
chomp $password;

close (UPFILE);

$HOSTNAME = "yoshi.tosh.no";
$PORTNO = 5747;

$sock = IO::Socket::INET->new(PeerPort=>$PORTNO, Proto=>'udp', PeerAddr=>$HOSTNAME) or die "Can't bind: $@\n";
print "Sending..\n";
$sock->send($username) or die "cannot send to $HOSTNAME($PORTNO): $!";
$MAXLEN = 1024;
$authString = "";

$sock->recv($authString, $MAXLEN, 1024) or die "recv: $!";
$host = gethostbyaddr($ipaddr, AF_INET);


if(length($authString)<8){
    print "Auth '$username' failed, user not found or key too short\n";
    exit 1;
}
print length($authString);
$hash = md5_hex $authString;

if($hash eq $password){
    exit 0;
}else{
    print "Wrong password ($hash vs $password)\n";
    exit 2;
}
